#include "Emitter.h"
#include "helper.h"

Emitter::Emitter(const Vector &pos, const Vector &dir, float speed, float size, bool isOn) :
  _pos(pos),
  _direction(dir),
  _speed(speed),
  _size(size),
  _isOn(isOn)
  {}

void Emitter::emit(int &N, std::vector<Particle> &particles, int max) {

  if(!_isOn)
    return;

  float Vemit = 4.0 / 3.0 * M_PI * _size * _size * _size;
  float Vpart = 4.0 / 3.0 * M_PI * 2 * 2 * 2;

  int steps = MIN(Vemit / Vpart, max - N);

  for(int i = 0 ; i < steps ; i++) {
    float r = RAND(0.0, _size);
    float psi = RAND(0.0, 2.0 * M_PI);
    float h = RAND(-1, 1);
    Vector x = Vector(r * cos(psi), 
                      r * sin(psi), 
                      r * h );

    particles.push_back(Particle(_pos + x, _speed * _direction));
    N++;
  }
}
   
