#include "Feedback.h"
#include "helper.h"

Feedback::Feedback(bool isOn) : _isOn(isOn) {}

void Feedback::computeHeigths(std::vector<float> &h, const std::vector<float> &x, const std::vector<Particle> &particles, const Parameters &pm) {
  std::vector<Particle>::const_iterator it = particles.begin();

  if(h.size() != x.size())
    throw("Sizes must be the same");

  for(int i = 0 ; i < h.size() ; i++)
    h[i] = 0;

  while (it != particles.end()) {
    for(int i = 0 ; i < x.size() ; i++) {
      if(ABS(it->_x.x - x[i]) <= 3*(pm.particle_radius / pm.simscale)) {
        if(it->_x.z > h[i])
          h[i] = it->_x.z;
      }
    }
    it++;
  }
}

void Feedback::computeAcc(const std::vector<float> &h, Parameters &pm) {
  if(!_isOn)
    return;

  float dt = pm.dt,
        ss = pm.simscale,
        hmoy  = (h[0] - h[h.size() - 1]) * 0.5;
  static float hold = hmoy;

  pm.feedback.x = 25 * (hold - hmoy) * ss / dt;
  hold = hmoy;
}
