#include "common_defs.h"
#include "gl_helper.h"
#include <string.h>
#include <math.h>


// Fonts
void *font = GLUT_BITMAP_8_BY_13;
void *fonts[] = {GLUT_BITMAP_9_BY_15,
				 GLUT_BITMAP_TIMES_ROMAN_10,
				GLUT_BITMAP_TIMES_ROMAN_24};

GLuint glSphere = 65535;
float  glRadius = 0.0;

void setSphereRadius ( float r )
{
	if ( glRadius == r ) return;
	glRadius = r;

	// GL sphere
	if ( glSphere != 65535 ) glDeleteLists ( glSphere, 1 );
	glSphere = glGenLists ( 1 );
	float x, y, z, x1, y1, z1;
	glNewList ( glSphere, GL_COMPILE );
		glBegin ( GL_TRIANGLE_STRIP );
		for ( float tilt=-90; tilt <= 90; tilt += 10.0) {
			for ( float ang=0; ang <= 360; ang += 30.0) {
				x = sin ( ang*DEGtoRAD) * cos ( tilt*DEGtoRAD );
				y = cos ( ang*DEGtoRAD) * cos ( tilt*DEGtoRAD );
				z = sin ( tilt*DEGtoRAD ) ;
				x1 = sin ( ang*DEGtoRAD) * cos ( (tilt+10.0)*DEGtoRAD ) ;
				y1 = cos ( ang*DEGtoRAD) * cos ( (tilt+10.0)*DEGtoRAD ) ;
				z1 = sin ( (tilt+10.0)*DEGtoRAD );
				glNormal3f ( x, y, z );		glVertex3f ( x*r, y*r, z*r );
				glNormal3f ( x1, y1, z1 );	glVertex3f ( x1*r, y1*r, z1*r );
			}
		}
		glEnd ();
	glEndList ();
}

void drawSphere ()
{
	if ( glRadius == 0.0 ) setSphereRadius ( 1.0 );
	glCallList ( glSphere );
}

void drawText ( int x, int y, char* msg)
{
  int len, i;
  glRasterPos2f(x, y);
  len = (int) strlen(msg);
  for (i = 0; i < len; i++)
    glutBitmapCharacter(font, msg[i]);
}

void drawGrid ()
{
	glColor3f ( 0.3, 0.3, 0.3 );
	glBegin ( GL_LINES );
	for (float x=-40; x<=40.0; x+=10.0 ) {
		glVertex3f ( x, -40.0, 0 );
		glVertex3f ( x,  40.0, 0 );
	}
	for (float y=-40; y<=40.0; y+=10.0 ) {
		glVertex3f ( -40.0, y, 0 );
		glVertex3f (  40.0, y, 0 );
	}
	glEnd ();
}
